require 'open-uri'
require 'nokogiri'
require 'active_support/core_ext/hash/conversions'

module Spellcard
  class Checker
    def find_typo(text)
      array = word_array(text)
      array.each.inject(Array.new) do |result, word|
        if is_english_word(word) == false
          result << word
        else
          result
        end
      end      
    end

    def word_array(text)
      text.split(' ').map { |word| word.gsub(/,/, "").gsub(/\./, "") }
    end

    def is_english_word(word)
      begin
        uri = 'http://public.dejizo.jp/NetDicV09.asmx/SearchDicItemLite?' +
          'Dic=EJdict&Scope=HEADWORD&Merge=AND&Prof=XHTML&PageSize=20' + 
          '&PageIndex=0&Match=EXACT&Word=' + word      
        doc = Nokogiri::XML(open(uri).read)
        hash = Hash.from_xml(doc.to_s)
        count = hash["SearchDicItemResult"]["TotalHitCount"].to_i
        if count == 0
          false
        else
          true
        end
      rescue
        true
      end
    end
  end
end
